#----------------------------------------
#
# $Id: run-star-tail.pl.in,v 1.85 2005/08/05 19:55:44 rader Exp $
#

# FIXME: this really should be dynamic via PollingInterval[]...

# this prevents incorrect data spikes by preventing
# RRDtool from interpolating counter roll-overs...

$uptime_thres = 600;  # paranoid: twice the (5min) polling interval 

$num_targets = 0;
$num_gathered = 0;
$num_not_gathered = 0;
$num_logged = 0;
$num_not_logged = 0;

target:
for $t ( 0 .. $#details) {

  #----------------------------------------
  # support -t TargetName syntax...

  if ( $target_target ) {
    if ( $details[$t][0][0] eq $target_target ) {
      $found = 1;
    } else {
      next target;
    }
  }
  
  #----------------------------------------
  # get the values...

  undef $dss;
  undef $values;
  undef $first_timestamp;

  if ( $debug ) { 
    print '#', "-" x 50, "\n";
    print "$details[$t][0][0]: started at ",scalar localtime(time),
      ' (', time, ")\n";
  }

  $num_targets++;
  $num_dss_for_this_target = ($#{$details[$t]} + 1);

  if ( $details[$t][0][3] !~ /^exec/ ) {

    #----------------------------------------
    # process SNMP target... 
    $target = $details[$t][0][0];
    $system = $details[$t][0][1];
    $passwd = $details[$t][0][2];
    $rrd = $details[$t][0][5];
    $timeout = $details[$t][0][6];
    $snmp_type = $details[$t][0][7];
    $snmp_args = '-v2c';
    if ( $system =~ /^(\S+)+:(\d+)$/ ) {
      $system = $1;
      $port = $2;
      $snmp_args .= "-p $port";
    }

    #----------------------------------------
    # performance tweak... if it's down once,
    # (quickly) assume it's down for this run...
    if ( grep /^$system$/, @downsnmpagents ) {
      print "skipping data collection for $target...\n";
      print "SNMP not responding at $system\n";
      $failures++;
      $num_not_gathered += $num_dss_for_this_target;
      $num_not_logged += $num_dss_for_this_target;
      next target;
    }

    #--------------------------------------------------

    $snmpget_cmd = "$snmpget $snmp_args -c $passwd $system";
    $debug_cmd = "$snmpget_terse $snmp_args -c $passwd $system";

    #--------------------------------------------------
    # logging SNMP counter values for routers that have
    # just rebooted (within the NRG polling interval)
    # usually results in spikes in NRG graphs... logging
    # U tells RRDtool to log the value "unknown" and thus
    # prevents the spikes...
    if ( $debug ) { print "$snmpget_cmd system.sysUpTime.0\n"; }
    $get_has_timed_out = 0;
    alarm $timeout;
    if ( ! open(IN,"$snmpget_cmd system.sysUpTime.0 2>&1|") ) {
      print "can't execute $snmpget_cmd system.sysUpTime.0\n";
      alarm 0;
      &abend;
    }
    $output = <IN>;
    close(IN);
    alarm 0;
    chomp $output;
    if ( $output =~ /Timeticks:\s*\((\d+)\)/ ) {
      $uptime = $1;
      if ( $uptime < $uptime_thres * 100 ) {  
        printf "sysUpTime for $target is %d seconds...\n", $uptime/100;
        printf "sysUpTime is less than threshold of $uptime_thres seconds\n";
        print "logging \"U\" to avoid data spike!\n";
        for $i ( 0 .. $#{$details[$t]} ) { 
          $values .= 'U:'; 
          $dss .= "$details[$t][$i][4]:";
        }
        $stamp = time;
        $failures++;
      } else {
        if ( $debug ) { 
          printf "okay: up for %d seconds (threshold is $uptime_thres)\n", $uptime/100;	
        }
      }
    } elsif ( ! $get_has_timed_out ) {
      if ( $debug ) { print "did not parse TimeTicks outa \"$output\"\n"; }
      # sometimes sysUpTime is reported as a *negative*
      # number...  eg ciscos or maybe just broken snmp
      # on the NRG server end... so we don't bitch about
      # negative sysUpTime...
      if ( $output !~ /Timeticks:\s*\(\-*(\d+)\)/ ) {
        # bitch about bad sysUpTime
        print "can not parse TimeTicks from\n";
        print "sysUpTime output \"$output\" \n";
      }
    }
    
    if ( ! $values ) {
      $snmpget_cmd = "$snmpget -On -Oq $snmp_args $system -c $passwd ";
      $debug_cmd = "$snmpget_terse -On -Oq $snmp_args $system -c $passwd";
      #--------------------------------------------------
      # do snmp 
      if ( $debug ) { print "$debug_cmd"; }
      for $i ( 0 .. $#{$details[$t]} ) {
        $snmpget_cmd .= "$details[$t][$i][3] ";
        $dss .= "$details[$t][$i][4]:";
        if ( $i != $#{$details[$t]} ) { 
          $debug_cmd .= " $details[$t][$i][3]"; 
          if ( $debug ) { print " $details[$t][$i][3]"; }
        } else { 
          $debug_cmd .= " $details[$t][$i][3] 2>&1\n"; 
          if ( $debug ) { print " $details[$t][$i][3] 2>&1\n"; }
        }
      }
      $snmpget_cmd .= "2>&1";
      $stamp = time;
      $get_has_timed_out = 0;
      alarm $timeout;
      if ( ! open(IN,"$snmpget_cmd|") ) {
        print "can't execute $snmpget_cmd\n";
        alarm 0;
        &abend;
      }
      @output = <IN>;
      close(IN);
      alarm 0;

      if ( $get_has_timed_out ) {
          print "data collection for $target timed out ($timeout secs)...\n";
          print "$debug_cmd";  # already has one \n
          push @downsnmpagents, $system;
          $failures++;
          $num_not_gathered += $num_dss_for_this_target;
          $num_not_logged += $num_dss_for_this_target;
          next target;
      }
      output_line:
      foreach $line (@output) {
        if ( $line =~ /.*? \s*(\d+)\s*$/ ) {
          $values .= "$1:";
        } else {
          chomp $line;
          $line =~ s/\n/ /g;
          $line =~ s/  / /g;
          print "snmpget for $target failed...\n";
          print "$debug_cmd";  # already has one \n
          print "$line\n";
          shift @output;  # ... snarf the first line
          $line = shift @output;
          chomp $line;
          print "$line\n";
          $failures++;
          $num_not_gathered += $num_dss_for_this_target;
          $num_not_logged += $num_dss_for_this_target;
          next target;
        }
      }
    }
  } else {
    #----------------------------------------
    # process non-SNMP target...
    variable_instance:
    for $i ( 0 .. $#{$details[$t]} ) {
      $target = $details[$t][$i][0];
      $system = $details[$t][$i][1];
      $passwd = $details[$t][$i][2];
      $var = $details[$t][$i][3];
      $ds = $details[$t][$i][4];
      $num_dss++;
      $rrd = $details[$t][$i][5];
      $timeout = $details[$t][$i][6];
      $get_has_timed_out = 0;
      $cmd = $var;
      $cmd =~ s/^exec //;
      $cmd .= " 2>&1";

      #----------------------------------------
      # performance tweak... if it's down once...
      if ( grep /^${passwd}@${system}$/, @downhosts ) {
        print "skipping data collection for $target...\n";
        print "data collection at ${passwd}\@${system} previously failed\n";
        print "data collection for $target failed\n"; 
        $failures++;
        $num_not_gathered++;
        $num_not_logged++;
        next target;
      }

      if ( $debug ) { print "$cmd\n"; }
      $get_has_timed_out = 0;
      $old_stamp = $stamp;
      alarm $timeout;
      if ( ! open(IN,"$cmd|") ) {
        print "can't execute $cmd\n";
        $failures++;
        $num_not_gathered += $num_dss_for_this_target;
        $num_not_logged += $num_dss_for_this_target;
        next variable_instance;
      }
      $stamp = <IN>; chop $stamp;
      $uptime = <IN>; chop $uptime;
      $value = <IN>; chop $value;
      close(IN); 
      alarm 0;

      if ( $get_has_timed_out ) {
        print "data collection for $target timed out ($timeout secs)...\n";
        print "$cmd\n";
        $stamp = $stamp_old;
        push @downhosts, "${passwd}\@${system}";
        $failures++;
        next variable_instance;
      }

      if ( $stamp eq '' ) {
        print "no output from collection script for $target...\n";
        print "$cmd\n";
        $stamp = $stamp_old;
        push @downhosts, $system;
        $failures++;
        next variable_instance;
      }

      if ( $uptime =~ /^\s*\d+/ ) {
        $uptime =~ s/^\s*(\d+).*/$1/;
      } elsif ( $uptime =~ /^INF/ ) {
      } else {
        print "can't parse uptime for $target...\n";
        print "$uptime\n";
        $stamp = $stamp_old;
        push @downhosts, $system;
        $failures++;
        next variable_instance;
      }

      if ( $stamp =~ /^\s*\d+/ ) {
        $stamp =~ s/^\s*(\d+).*/$1/;
      } elsif ( $stamp =~ /^-1/ ) {
        $stamp = -1;
      } else {
        $stamp =~ s/\n/ /g;
        $stamp =~ s/  / /g;
        print "can't parse time for $target...\n";
        print "$cmd\n";
        print "$stamp\n";
        $stamp = $stamp_old;
        push @downhosts, $system;
        $failures++;
        next variable_instance;
      }

      if ( $uptime !~ /^INF/ && $uptime < $uptime_thres ) {
        print "uptime for $target is $uptime seconds...\n";
        print "uptime is less than threshold of $uptime_thres seconds\n";
        print "logging \"U\" to avoid data spike!\n";
        for $i ( 0 .. $#{$details[$t]} ) {
          $value = 'U';
        }
        $stamp = time;
        $failures++;
      } elsif ( $value =~ /^(\d+\.\d+|\d+|U)\s+/ ) {
        $value = $1;
        if ( $debug ) { 
          $uptime =~ s/^(\d+|INF).*/$1/;
          print "uptime okay: uptime is \"$uptime\" (threshold is $uptime_thres)\n";
          print "value okay: $target $ds is \"$value\"\n";
        }
      } else {
        $value =~ s/\n/ /g;
        $value =~ s/  / /g;
        print "could not get value for $ds for $target...\n";
        print "$value\n";
        $stamp = $stamp_old;
        push @downhosts, $system;
        $failures++;
        next variable_instance;
      }

      $dss .= "$details[$t][$i][4]:";
      $values .= "$value:";
    }
  }
  
  #----------------------------------------
  # store the values...

  if ( ! $values ) {
    # if all the data collection failed, don't 
    # bother trying rrdtool update...
    $dss =~ s/(\S+),\s*$/$1/;
    $dss =~ s/(\S+),\s*(\S+)\s*$/$1 and $2/;
    print "skipping rrdtool update for $dss for $target...\n";
    print "data collection failed\n";
    $failures++;
    $num_not_gathered += $num_dss_for_this_target;
    $num_not_logged += $num_dss_for_this_target;
    next target;
  }
  $num_gathered += $num_dss_for_this_target;

  chop $dss;  # remove trailing colon
  chop $values;  # remove trailing colon
  if ( $debug ) { print "okay: values for $dss are $values\n"; }

  $cmd = "$rrdtool update $rrd -t $dss ${stamp}:$values 2>&1";
  $debug_cmd = "$rrdtool_terse update $rrd -t $dss ${stamp}:$values 2>&1"; 
  if ( $debug ) { print "$debug_cmd\n"; };

  $get_has_timed_out = 0;
  alarm 5;  ;# is it evil to assume rrdtool can execute in < 5 secs??
  $out = `$cmd`;
  alarm 0;

  if ( $get_has_timed_out ) {
    print "commmand timed out...\n";
    print "$debug_cmd\n";
    $failures++;
    $num_not_logged += $num_dss_for_this_target;
    next target;
  } 
  if ( $out !~ /^\s*$/ ) {
    $out =~ s/\n/ /g;
    $out =~ s/  / /g;
    print "rrdtool update failed...\n";
    print "$debug_cmd\n";
    print "$out\n";
    $failures++;
    $num_not_logged += $num_dss_for_this_target;
    next target;
  } 
  if ( $debug ) { print "update okay: rrdtool update succeeded\n"; }
  $num_logged += $num_dss_for_this_target;
  
  if ( $debug && 'yes' eq 'yes' ) { # VERBOSE_RUN_DEBUG == yes
    print "$dsreport -now $rrd\n";
    print `$dsreport -now $rrd`;
  }

} ;# end of each target


#----------------------------------------
# report about what happened...

if ( $target_target && !($found) ) {
  print "target $target_target not found!\n";
}

if ( $debug ) { print '#', "-" x 50, "\n"; }

($sec,$min,$hr,$day,$mon,$yr) = (localtime($start))[0,1,2,3,4,5];
$mon++;
$yr = $yr%100;
$d_str = sprintf("%2.2d/%2.2d/%2.2d %2.2d:%2.2d:%2.2d (%d)",
  $mon,$day,$yr,$hr,$min,$sec,$start);

print <<_EOT_;
${d_str}: processed $num_targets targets
${d_str}: gathered $num_gathered datapoints
${d_str}: failed to gather $num_not_gathered datapoints
${d_str}: logged $num_logged datapoints
${d_str}: failed to log $num_not_logged datapoints
_EOT_
$finish = time;
$diff = $finish - $start;
printf "${d_str}: elapsed time %2.2d:%2.2d:%2.2d (%d secs)\n", 
  int($diff/60/60)%60, int($diff/60)%60, $diff%60, $diff;

print "$progname $$: finished at ", scalar localtime($finish), " ($finish)\n";
print '#', "-" x 79, "\n\n";

#----------------------------------------
# unlock and exit...

unlink $lock;

exit 0;


#==============================================================================

sub abend {
  unlink $lock;
  die "$progname: terminated on ", scalar localtime(time), " (",time,")\n\n";
}

#------------------------------------------------------------------

sub timed_out {
  local $SIG{HUP} = 'IGNORE';
  kill('HUP', -$$);
  $get_has_timed_out = 1;
  if ( $debug ) { print "timeout\n"; }
}

